// TaskSchedulerHelper.cpp : t@C
//

#include "stdafx.h"
#include "TaskSchedulerHelperApp.h"
#include "TaskSchedulerHelperDlg.h"
#include <initguid.h>
#include <mstask.h>
#include <shlwapi.h>
#include <locale.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define INI_FILE	_T(".\\TaskSchedulerHelper_setting.ini")

// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTaskSchedulerHelper _CAO




CTaskSchedulerHelper::CTaskSchedulerHelper(CWnd* pParent /*=NULL*/)
	: CDialog(CTaskSchedulerHelper::IDD, pParent)
	, strCapsts(_T(""))
	, strFilename(_T("test.ts2"))
	, strChannel(_T(""))
	, strId(_T(""))
	, strCommandline(_T(""))
	, bPowerOn(FALSE)
	, bPowerOff(FALSE)
	, bBcs(FALSE)
	, bB25(FALSE)
	, strTaskName(_T(""))
	, nTaskType(0)
	, bDelTask(FALSE)
	, bResume(FALSE)
	, strAccount(_T(""))
	, strPass1(_T(""))
	, strPass2(_T(""))
	, cmdline(NULL)
	, bSel(FALSE)
	, bAutoClose(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	wcscpy_s(wFilename, 256, L"");
	wcscpy_s(wParameter, 256, L"");

	wchar_t temp[256];
	GetPrivateProfileStringW(L"cap_sts", L"cap_sts_path", L"cap_sts.exe", temp, 256,INI_FILE);
	strCapsts = temp;
	GetPrivateProfileStringW(L"cap_sts", L"vlc_parm", L"MP2_PS",temp,256,INI_FILE);
	strVlcParam = temp;

	GetPrivateProfileStringW(L"cap_sts", L"channel", L"001", temp, 256,INI_FILE);
	strChannel = temp;
	GetPrivateProfileStringW(L"cap_sts", L"id", L"0", temp, 256,INI_FILE);
	strId = temp;
	bPowerOn = GetPrivateProfileIntW(L"cap_sts", L"power_on", 0,INI_FILE);
	bPowerOff = GetPrivateProfileIntW(L"cap_sts", L"power_off", 0,INI_FILE);
	bBcs = GetPrivateProfileIntW(L"cap_sts", L"bcs", 1,INI_FILE);
	bB25 = GetPrivateProfileIntW(L"cap_sts", L"b25", 0,INI_FILE);
	bVlc = GetPrivateProfileIntW(L"cap_sts", L"vlc", 0,INI_FILE);
	bSel = GetPrivateProfileIntW(L"cap_sts", L"sel", 0,INI_FILE);

	GetPrivateProfileStringW(L"task", L"account", L"", temp, 256,INI_FILE); 
	strAccount = temp;
	GetPrivateProfileStringW(L"task", L"pass", L"", temp, 256,INI_FILE); 
	strPass1 = temp;
	strPass2 = temp;
	bDelTask = GetPrivateProfileIntW(L"task", L"del_task", 1,INI_FILE);
	bResume = GetPrivateProfileIntW(L"task", L"resume", 1,INI_FILE);
	bAutoClose = GetPrivateProfileIntW(L"system", L"autoclose", 0,INI_FILE);
}

void CTaskSchedulerHelper::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_CAPSTS_EDIT, strCapsts);
	DDX_Text(pDX, IDC_FILENAME_EDIT, strFilename);
	DDX_Text(pDX, IDC_VLC_PARAM, strVlcParam);
	
	DDX_Text(pDX, IDC_CHANNEL_EDIT, strChannel);

	DDX_Text(pDX, IDC_ID_EDIT, strId);
	DDX_Text(pDX, IDC_COMMANDLINE_EDIT, strCommandline);
	DDX_Check(pDX, IDC_PON_CHECK, bPowerOn);
	DDX_Check(pDX, IDC_POFF_CHECK, bPowerOff);
	DDX_Check(pDX, IDC_BCS_CHECK, bBcs);
	DDX_Check(pDX, IDC_B25_CHECK, bB25);
	DDX_Check(pDX, IDC_VLCREC, bVlc);
	DDX_Control(pDX, IDC_DATETIMEPICKER1, ctrlDateTime1);
	DDX_Control(pDX, IDC_DATETIMEPICKER2, ctrlDateTime2);
	DDX_Text(pDX, IDC_TASK_NAME_EDIT, strTaskName);
	DDX_Control(pDX, IDC_MONTHCALENDAR1, ctrlCal);
	DDX_Radio(pDX, IDC_RADIO3, nTaskType);
	DDX_Check(pDX, IDC_CHECK1, bDelTask);
	DDX_Check(pDX, IDC_CHECK2, bResume);
	DDX_Text(pDX, IDC_TASK_NAME_EDIT2, strAccount);
	DDX_Text(pDX, IDC_TASK_NAME_EDIT3, strPass1);
	DDX_Text(pDX, IDC_TASK_NAME_EDIT4, strPass2);
	DDX_Control(pDX, IDC_LIST2, ctrlChannelList);
	DDX_Check(pDX, IDC_SEL_CHECK, bSel);
	DDX_Check(pDX, IDC_AUTO_CLOSE_CHECK, bAutoClose);
}

BEGIN_MESSAGE_MAP(CTaskSchedulerHelper, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDOK, &CTaskSchedulerHelper::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CTaskSchedulerHelper::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_CAPSTS_BUTTON, &CTaskSchedulerHelper::OnBnClickedCapstsButton)
	ON_BN_CLICKED(IDC_PON_CHECK, &CTaskSchedulerHelper::OnBnClickedCheck)
	ON_BN_CLICKED(IDC_POFF_CHECK, &CTaskSchedulerHelper::OnBnClickedCheck)
	ON_BN_CLICKED(IDC_BCS_CHECK, &CTaskSchedulerHelper::OnBnClickedCheck)
	ON_BN_CLICKED(IDC_B25_CHECK, &CTaskSchedulerHelper::OnBnClickedCheck)
	ON_BN_CLICKED(IDC_SEL_CHECK, &CTaskSchedulerHelper::OnBnClickedCheck)
	ON_BN_CLICKED(IDC_CAPSTS_BUTTON2, &CTaskSchedulerHelper::OnBnClickedCapstsButton2)
	ON_BN_CLICKED(IDC_TASK_SET_BUTTON, &CTaskSchedulerHelper::OnBnClickedTaskSetButton)
	ON_BN_CLICKED(IDC_EPG_BUTTON, &CTaskSchedulerHelper::OnBnClickedEpgButton)
	ON_EN_CHANGE(IDC_CAPSTS_EDIT, &CTaskSchedulerHelper::OnEnChangeEdit)
	ON_EN_CHANGE(IDC_FILENAME_EDIT, &CTaskSchedulerHelper::OnEnChangeEdit)
	ON_EN_CHANGE(IDC_ID_EDIT, &CTaskSchedulerHelper::OnEnChangeEdit)
	ON_EN_CHANGE(IDC_CHANNEL_EDIT, &CTaskSchedulerHelper::OnEnChangeEdit)
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_DATETIMEPICKER1, &CTaskSchedulerHelper::OnDtnDatetimechangeDatetimepicker)
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_DATETIMEPICKER2, &CTaskSchedulerHelper::OnDtnDatetimechangeDatetimepicker)
	ON_LBN_SELCHANGE(IDC_LIST2, &CTaskSchedulerHelper::OnLbnSelchangeList2)
	ON_BN_CLICKED(IDC_VLCREC, &CTaskSchedulerHelper::OnBnClickedCheck)
END_MESSAGE_MAP()


// CTaskSchedulerHelper bZ[W nh

BOOL CTaskSchedulerHelper::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	LoadChannelFile();
	for(int i = 0; i < channel_number; i++){
		ctrlChannelList.AddString(channel[i].name);
		if(wcsstr(channel[i].command, strChannel) != NULL) ctrlChannelList.SetCurSel(i);
	}

	ctrlDateTime1.SetFormat(L"HH:mm");
	ctrlDateTime2.SetFormat(L"HH:mm");

	if(wcslen(cmdline) > 0){
//		AfxMessageBox(cmdline);
		wchar_t epg_file_path[256];
		if(cmdline[0] != '"'){
			wcscpy_s(epg_file_path, 256, cmdline);
		}else{
			wcsncpy_s(epg_file_path, 256, &cmdline[1], wcslen(cmdline) -2);
		}
		EPG epg;
		if(OpenEPGFile(epg_file_path, &epg)){
			SetEPG(&epg);
		}
	}
	MakeCommandline();

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CTaskSchedulerHelper::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CTaskSchedulerHelper::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CTaskSchedulerHelper::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTaskSchedulerHelper::OnBnClickedCapstsButton()
{
	UpdateData(TRUE);

	wchar_t wFilename[WCHAR_MAX];
	wcscpy_s(&wFilename[0], WCHAR_MAX, L"cap_sts.exe");

	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.lpstrFilter = L"st@C\0*.exe;*.bat\0SẴt@C\0*.*\0\0";
	ofn.lpstrFile = wFilename;
	ofn.nMaxFile = WCHAR_MAX;
	ofn.lpstrDefExt = L"exe";
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;

	if( GetOpenFileNameW(&ofn) != TRUE) return;

	strCapsts = wFilename;
	MakeCommandline();
}

void CTaskSchedulerHelper::MakeCommandline(void)
{
	CString strTemp;
	wchar_t *end;

	wcscpy_s(wFilename, 256, strCapsts);
	strTemp.Format(_T("\"%s\""), strFilename);
	wcscpy_s(wParameter, 256, strTemp);
	wcscat_s(wParameter, 256, L" @"+strChannel);

	CTime StartTime, EndTime;
	ctrlDateTime1.GetTime(StartTime);
	ctrlDateTime2.GetTime(EndTime);
	wchar_t temp[256];
	swprintf_s(temp, L" %0.2u:%0.2u-%0.2u:%0.2u", StartTime.GetHour(), StartTime.GetMinute(), EndTime.GetHour(), EndTime.GetMinute());
	wcscat_s(wParameter, 256, temp);

	if(bVlc){
		wcscat_s(wParameter, 256, L" vlc:");
		wcscat_s(wParameter, 256, strVlcParam);
	}
	if(bPowerOn) wcscat_s(wParameter, 256, L" P");
	if(bPowerOff) wcscat_s(wParameter, 256, L" POFF");
	if(bBcs)wcscat_s(wParameter, 256,  L" B");
	if(bB25) wcscat_s(wParameter, 256, L" B25");
	if(bSel) wcscat_s(wParameter, 256, L" SEL");

	if(wcstod(strId, &end) != 0) wcscat_s(wParameter, 256, L" I"+strId);

	strCommandline = wFilename;
	strCommandline += " ";
	strCommandline += wParameter;
	UpdateData(FALSE);
}

void CTaskSchedulerHelper::OnBnClickedCheck()
{
	UpdateData(TRUE);
	MakeCommandline();
}

void CTaskSchedulerHelper::OnEnChangeEdit()
{
	UpdateData(TRUE);
	MakeCommandline();
}

void CTaskSchedulerHelper::OnDtnDatetimechangeDatetimepicker(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMDATETIMECHANGE pDTChange = reinterpret_cast<LPNMDATETIMECHANGE>(pNMHDR);
	UpdateData(TRUE);
	MakeCommandline();
	*pResult = 0;
}

void CTaskSchedulerHelper::OnBnClickedCapstsButton2()
{
	UpdateData(TRUE);

	wchar_t wFilename[WCHAR_MAX];
	wcscpy_s(&wFilename[0], WCHAR_MAX, strFilename);

	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.lpstrFilter = L"ts2t@C\0*.ts2;*.ts\0SẴt@C\0*.*\0\0";
	ofn.lpstrFile = wFilename;
	ofn.nMaxFile = WCHAR_MAX;
	ofn.lpstrDefExt = L"ts2";
	ofn.Flags = OFN_NOCHANGEDIR;

	if( GetOpenFileNameW(&ofn) != TRUE) return;

	strFilename = wFilename;
	MakeCommandline();
}

void CTaskSchedulerHelper::OnClose()
{
	UpdateData(TRUE);
	CString temp;
	WritePrivateProfileStringW(L"cap_sts", L"cap_sts_path", strCapsts,INI_FILE);
	WritePrivateProfileStringW(L"cap_sts", L"vlc_parm", strVlcParam,INI_FILE);
	WritePrivateProfileStringW(L"cap_sts", L"channel", strChannel,INI_FILE);
	WritePrivateProfileStringW(L"cap_sts", L"id", strId,INI_FILE);
	temp.Format(_T("%u"), bPowerOn);
	WritePrivateProfileStringW(L"cap_sts", L"power_on", temp,INI_FILE);
	temp.Format(_T("%u"), bPowerOff);
	WritePrivateProfileStringW(L"cap_sts", L"power_off", temp,INI_FILE);
	temp.Format(_T("%u"), bBcs);
	WritePrivateProfileStringW(L"cap_sts", L"bcs", temp,INI_FILE);
	temp.Format(_T("%u"), bB25);
	WritePrivateProfileStringW(L"cap_sts", L"b25", temp,INI_FILE);
	temp.Format(_T("%u"), bSel);
	WritePrivateProfileStringW(L"cap_sts", L"sel", temp,INI_FILE);
	temp.Format(_T("%u"), bVlc);
	WritePrivateProfileStringW(L"cap_sts", L"vlc", temp,INI_FILE);

	WritePrivateProfileStringW(L"task", L"account", strAccount,INI_FILE);
	WritePrivateProfileStringW(L"task", L"pass", strPass1,INI_FILE);
	temp.Format(_T("%u"), bDelTask);
	WritePrivateProfileStringW(L"task", L"del_task", temp,INI_FILE);
	temp.Format(_T("%u"), bResume);
	WritePrivateProfileStringW(L"task", L"resume", temp,INI_FILE);

	temp.Format(_T("%u"), bAutoClose);
	WritePrivateProfileStringW(L"system", L"autoclose", temp,INI_FILE);

	EndDialog(0);
	CDialog::OnClose();
}

#define TASKS_TO_RETRIEVE          5
void CTaskSchedulerHelper::OnBnClickedTaskSetButton()
{
	UpdateData(TRUE);
	if(strTaskName.GetLength() == 0){
		AfxMessageBox(L"ݒ薼͂Ă");
		return;
	}
	if(strAccount.GetLength() == 0){
		AfxMessageBox(L"sAJEg͂Ă");
		return;
	}
/*
	if(strPass1 != strPass2){
		AfxMessageBox(L"pX[hԈĂ܂");
		return;
	}
*/
	HRESULT hr = S_OK;
	ITaskScheduler *pITS;

	hr = CoInitialize(NULL);
	if (SUCCEEDED(hr)){
		hr = CoCreateInstance(CLSID_CTaskScheduler, NULL, CLSCTX_INPROC_SERVER, IID_ITaskScheduler, (void **) &pITS);
		if (FAILED(hr)){
			CoUninitialize();
			return;
		}
	}else{
		return;
	}

	IEnumWorkItems *pIEnum;
	hr = pITS->Enum(&pIEnum);
	if (FAILED(hr)){
		CoUninitialize();
		return;
	}
	wchar_t temp[256];
	wcscpy_s(temp, 256, strTaskName.GetString());
	wcscat_s(temp, 256, L".job");

	LPWSTR *lpwszNames;
	DWORD dwFetchedTasks = 0;
	while (SUCCEEDED(pIEnum->Next(TASKS_TO_RETRIEVE, &lpwszNames, &dwFetchedTasks)) && (dwFetchedTasks != 0)){
		while (dwFetchedTasks){
			if(wcscmp(lpwszNames[--dwFetchedTasks], temp) == 0){
				AfxMessageBox(L"ɓo^܂\r\nႤo^͂Ă");
				return;
			}
			CoTaskMemFree(lpwszNames[dwFetchedTasks]);
		}
		CoTaskMemFree(lpwszNames);
	}
	pIEnum->Release();

	ITask *pITask;
	IPersistFile *pIPersistFile;
	hr = pITS->NewWorkItem(strTaskName, CLSID_CTask, IID_ITask, (IUnknown**)&pITask);

	if (FAILED(hr)){
		pITask->Release();
		CoUninitialize();
		return;
	}

	hr = pITask->SetAccountInformation(strAccount.GetString(), strPass1.GetString());
	hr = pITask->SetApplicationName(wFilename);
	wchar_t *p = wcsrchr(wFilename, L'\\');
	wchar_t path[256];
	wcsncpy_s(path, 256, wFilename, p - &wFilename[0]);
	hr = pITask->SetWorkingDirectory(path);
	hr = pITask->SetParameters(wParameter);

	// gK[ݒ
	ITaskTrigger *pITaskTrigger;
	WORD piNewTrigger;
	hr = pITask->CreateTrigger(&piNewTrigger, &pITaskTrigger);
	if (FAILED(hr)){
		pITask->Release();
		CoUninitialize();
		return;
	}

	TASK_TRIGGER pTrigger;
	ZeroMemory(&pTrigger, sizeof (TASK_TRIGGER));

	CTime SetTime;
	ctrlDateTime1.GetTime(SetTime);
	pTrigger.wStartHour = SetTime.GetHour();
	pTrigger.wStartMinute = SetTime.GetMinute() -1;	//ꕪOɃ^XNN
	ctrlCal.GetCurSel(SetTime);
	pTrigger.wBeginDay = SetTime.GetDay();
	pTrigger.wBeginMonth = SetTime.GetMonth();
	pTrigger.wBeginYear = SetTime.GetYear();
	pTrigger.cbTriggerSize = sizeof(TASK_TRIGGER);

	DWORD flag = TASK_FLAG_RUN_ONLY_IF_LOGGED_ON;
	if(bDelTask) flag |= TASK_FLAG_DELETE_WHEN_DONE;
	if(bResume) flag |= TASK_FLAG_SYSTEM_REQUIRED;
	hr = pITask->SetFlags(flag);

	switch(nTaskType){
		case 0:
			pTrigger.TriggerType = TASK_TIME_TRIGGER_ONCE;
			break;
		case 1:
			pTrigger.TriggerType = TASK_TIME_TRIGGER_DAILY;
			pTrigger.Type.Daily.DaysInterval = 1;
			break;
		case 2:
			pTrigger.TriggerType = TASK_TIME_TRIGGER_WEEKLY;
			pTrigger.Type.Weekly.WeeksInterval = 1;
			switch(SetTime.GetDayOfWeek()){
				case 1:
					pTrigger.Type.Weekly.rgfDaysOfTheWeek = TASK_SUNDAY;
					break;
				case 2:
					pTrigger.Type.Weekly.rgfDaysOfTheWeek = TASK_MONDAY;
					break;
				case 3:
					pTrigger.Type.Weekly.rgfDaysOfTheWeek = TASK_TUESDAY;
					break;
				case 4:
					pTrigger.Type.Weekly.rgfDaysOfTheWeek = TASK_WEDNESDAY;
					break;
				case 5:
					pTrigger.Type.Weekly.rgfDaysOfTheWeek = TASK_THURSDAY;
					break;
				case 6:
					pTrigger.Type.Weekly.rgfDaysOfTheWeek = TASK_FRIDAY;
					break;
				case 7:
					pTrigger.Type.Weekly.rgfDaysOfTheWeek = TASK_SATURDAY;
					break;
				default:
					pTrigger.Type.Weekly.rgfDaysOfTheWeek = TASK_SUNDAY;
					break;
			}
			pTrigger.rgFlags = TASK_FLAG_RESTART_ON_IDLE_RESUME | TASK_FLAG_RUN_ONLY_IF_LOGGED_ON;
			break;
		default:
			pTrigger.TriggerType = TASK_TIME_TRIGGER_ONCE;
			break;
	}

	hr = pITaskTrigger->SetTrigger (&pTrigger);
	if (FAILED(hr))
	{
		pITask->Release();
		pITaskTrigger->Release();
		CoUninitialize();
		return;
	}

	pITS->Release();
	if (FAILED(hr)){
		CoUninitialize();
		return;
	}

	hr = pITask->QueryInterface(IID_IPersistFile, (void **)&pIPersistFile);

	pITask->Release();
	if (FAILED(hr)){
		CoUninitialize();
		return;
	}

	hr = pIPersistFile->Save(NULL, TRUE);
	pIPersistFile->Release();
	if (FAILED(hr)){
		CoUninitialize();
		return;
	}
	AfxMessageBox(L"o^܂");
	if(bAutoClose) OnClose();
}

void CTaskSchedulerHelper::OnBnClickedEpgButton()
{
	wchar_t filename[WCHAR_MAX];
	filename[0] = '\0';

	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.lpstrFilter = L"iEPGt@C\0*.tvpid;*.tvpi;*.php;*.php3\0SẴt@C\0*.*\0\0";
	ofn.lpstrFile = filename;
	ofn.nMaxFile = WCHAR_MAX;
	ofn.lpstrDefExt = L"";
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;

	if( GetOpenFileNameW(&ofn) != TRUE) return;

	EPG epg;
	if(OpenEPGFile(filename, &epg)) SetEPG(&epg);
}

bool CTaskSchedulerHelper::OpenEPGFile(const wchar_t * filename, EPG * epg)
{
	FILE	*fp;
	wchar_t buffer[WCHAR_MAX];
	errno_t err;

	err = _wfopen_s(&fp, filename, L"rt");	//ǂݍݐpAeLXg[h
	if(fp == NULL){
		return false;
	}

	memset(epg, '\0', sizeof(EPG));
	epg->start.hour = epg->end.hour = 0xff;

	_wsetlocale(LC_CTYPE, L"Japanese");					//P[VZbg

	if(fgetws(buffer, WCHAR_MAX, fp) == NULL){	//sǂݍ(S-JIS -> Unicodeϊ)
		// gȂ
		return false;
	}else
		if(wcsstr(buffer, L"Content-type:") == NULL){
		// sڂɃRec^CvȂ
		return false;
	}else if((wcsstr(buffer, L"application/x-tv-program-info") == NULL)&&(wcsstr(buffer, L"application/x-tv-program-digital-info") == NULL)){
		// Rec^CvႤ
		return false;
	}	// charsetShiftJIŜݑΉ

	int state;
	wchar_t *endp;
	while(true){
		state = 0;
		if(fgetws(buffer, WCHAR_MAX, fp) == NULL) break;
		if(buffer[0] == '\n') state = 14;
		else{
			size_t len = wcslen(buffer);
			buffer[len -1] = '\0';	//sR[h㏑
		}

		if(wcsstr(buffer, L"version: ") != NULL) state = 1;
		if(wcsstr(buffer, L"station: ") != NULL) state = 2;
		if(wcsstr(buffer, L"year: ") != NULL) state = 3;
		if(wcsstr(buffer, L"month: ") != NULL) state = 4;
		if(wcsstr(buffer, L"date: ") != NULL) state = 5;
		if(wcsstr(buffer, L"start: ") != NULL) state = 6;
		if(wcsstr(buffer, L"end: ") != NULL) state = 7;
		if(wcsstr(buffer, L"program-title: ") != NULL) state = 8;
		if(wcsstr(buffer, L"program-subtitle: ") != NULL) state = 9;
		if(wcsstr(buffer, L"performer: ") != NULL) state = 10;
		if(wcsstr(buffer, L"genre: ") != NULL) state = 11;
		if(wcsstr(buffer, L"subgenre: ") != NULL) state = 12;
		if(wcsstr(buffer, L"Extend: ") != NULL) state = 13;

		switch(state){
			case 1:
				epg->version = (int)wcstol(&buffer[9], &endp, 10);
				break;
			case 2:
				wcscpy_s(epg->station, EPG_WORD_MAX, &buffer[9]);
				break;
			case 3:
				epg->year = (int)wcstol(&buffer[6], &endp, 10);
				break;
			case 4:
				epg->month = (int)wcstol(&buffer[7], &endp, 10);
				break;
			case 5:
				epg->date = (int)wcstol(&buffer[6], &endp, 10);
				break;
			case 6:
				epg->start.hour = (int)wcstol(&buffer[7], &endp, 10);
				epg->start.minutes = (int)wcstol(&endp[1], &endp, 10);
				break;
			case 7:
				epg->end.hour = (int)wcstol(&buffer[5], &endp, 10);
				epg->end.minutes = (int)wcstol(&endp[1], &endp, 10);
				break;
			case 8:
				wcscpy_s(epg->program_title, EPG_WORD_MAX, &buffer[15]);
				break;
			case 9:
				wcscpy_s(epg->program_subtitle, EPG_WORD_MAX, &buffer[18]);
				break;
			case 10:
				wcscpy_s(epg->performer, EPG_WORD_MAX, &buffer[11]);
				break;
			case 11:
				epg->genre = (int)wcstol(&buffer[7], &endp, 10);
				break;
			case 12:
				epg->subgenre = (int)wcstol(&buffer[10], &endp, 10);
				break;
			case 13:
				epg->extend = (int)wcstol(&buffer[8], &endp, 10);
				break;
			case 14:
				while(true){
					if(fgetws(buffer, WCHAR_MAX, fp) == NULL) break;
					wcscat_s(epg->memo, WCHAR_MAX, buffer);
				}
			default:
				break;
		}
	}
	fclose(fp);

	tm today;
	time_t time;
	_time64(&time);
	localtime_s(&today, &time);

	if((epg->version != 1)&&(epg->version != 2)) return false;
	if(epg->station[0] == '\0') return false;
	if((epg->start.hour == 0xff)||(epg->end.hour == 0xff)) return false;

	if(epg->year == 0) epg->year = today.tm_year + 1900;
	if(epg->month == 0) epg->month = today.tm_mon +1;
	if(epg->date == 0) epg->date = today.tm_mday;
	if(epg->start.minutes > 59) epg->start.minutes = 59;
	if(epg->start.hour > 23){
		epg->start.hour -= 23;
		epg->date += 1;
	}
	if(epg->end.minutes > 59) epg->end.minutes = 59;
	if(epg->end.hour > 23) epg->end.hour -= 23;

	return true;
}

void CTaskSchedulerHelper::LoadChannelFile(void)
{
	FILE	*fp;
	wchar_t buffer[WCHAR_MAX];

	_wsetlocale(LC_CTYPE, L"Japanese");					//P[VZbg

	channel_number = 0;
	memset(channel, '\0', sizeof(channel));

	wchar_t file[256];
	wchar_t *lastbackslash;
	GetModuleFileNameW(NULL,file,256);
	lastbackslash = wcsrchr(file, '\\');
	wcscpy_s(lastbackslash, 256 - (lastbackslash - &file[0]), L"\\channel.txt");

	_wfopen_s(&fp, file, L"r+t");	//ǂݍݐpAeLXg[h
	if(fp == NULL){
		return;
	}
	while(true){
		wchar_t *f, *n;
		if(fgetws(buffer, WCHAR_MAX, fp) == NULL) break;

		f = wcschr(&buffer[0], ',');
		wcsncpy_s(channel[channel_number].name, 32, &buffer[0], f - &buffer[0]);
		f++;
		n = wcschr(f, ',');
		wcsncpy_s(channel[channel_number].command, 10, f, n - f);
		n++;
		wcscpy_s(channel[channel_number].IdentificationWord, 128, n);
		channel_number++;
	}
	fclose(fp);
}

void CTaskSchedulerHelper::OnLbnSelchangeList2()
{
	UpdateData(TRUE);
	int num = ctrlChannelList.GetCurSel();
	strChannel = channel[num].command;

	MakeCommandline();
}

void CTaskSchedulerHelper::SetEPG(const EPG * epg)
{
		CTime sdt(epg->year, epg->month, epg->date, epg->start.hour, epg->start.minutes, 0);
		CTime edt(epg->year, epg->month, epg->date, epg->end.hour, epg->end.minutes, 0);
		ctrlCal.SetCurSel(sdt);
		ctrlDateTime1.SetTime(&sdt);
		ctrlDateTime2.SetTime(&edt);
		if(epg->program_subtitle[0] == '\0'){
			strFilename.Format(_T("%s.ts"), epg->program_title);
		}else{
			strFilename.Format(_T("%s-%s.ts"), epg->program_title, epg->program_subtitle);
		}
		strTaskName = epg->program_title;

		int i;
		for(i = 0;i < channel_number; i++){
			if(wcsstr(channel[i].IdentificationWord, epg->station) != NULL) break;
		}
		if(i == channel_number){
			strChannel = "";
			ctrlChannelList.SetCurSel(-1);
			AfxMessageBox(L"`lݒt@Cɖ`lłB\r\n蓮Ń`lR}h͂ĂB");
		}else{
			strChannel = channel[i].command;
			ctrlChannelList.SetCurSel(i);
		}

		UpdateData(false);
		MakeCommandline();
}

